Loading...
Searching...
No Matches
AVHWFramesContext Struct Reference

This struct describes a set or pool of "hardware" frames (i.e. More...

`#include <libavutil/hwcontext.h>`

## Data Fields

const AVClass * | av_class
| A class for logging.
AVBufferRef * | device_ref
| A reference to the parent AVHWDeviceContext.
AVHWDeviceContext * | device_ctx
| The parent AVHWDeviceContext.
void * | hwctx
| The format-specific data, allocated and freed automatically along with this context.
void(* | free )(struct AVHWFramesContext *ctx)
| This field may be set by the caller before calling av_hwframe_ctx_init().
void * | user_opaque
| Arbitrary user data, to be used e.g.
AVBufferPool * | pool
| A pool from which the frames are allocated by av_hwframe_get_buffer().
int | initial_pool_size
| Initial size of the frame pool.
enum AVPixelFormat | format
| The pixel format identifying the underlying HW surface type.
enum AVPixelFormat | sw_format
| The pixel format identifying the actual data layout of the hardware frames.
int | width
| The allocated dimensions of the frames in this pool.
int | height

## Detailed Description

This struct describes a set or pool of "hardware" frames (i.e.

those with data not located in normal system memory). All the frames in the pool are assumed to be allocated in the same way and interchangeable.

This struct is reference-counted with the AVBuffer mechanism and tied to a given AVHWDeviceContext instance. The av_hwframe_ctx_alloc() constructor yields a reference, whose data field points to the actual AVHWFramesContext struct.

Examples
  vaapi_encode.c.

Definition at line 118 of file hwcontext.h.

## Field Documentation

## av_class

const AVClass* AVHWFramesContext::av_class

A class for logging.

Definition at line 122 of file hwcontext.h.

## device_ref

AVBufferRef* AVHWFramesContext::device_ref

A reference to the parent AVHWDeviceContext.

This reference is owned and managed by the enclosing AVHWFramesContext, but the caller may derive additional references from it.

Definition at line 129 of file hwcontext.h.

## device_ctx

AVHWDeviceContext* AVHWFramesContext::device_ctx

The parent AVHWDeviceContext.

This is simply a pointer to device_ref->data provided for convenience.

Set by libavutil in av_hwframe_ctx_init().

Definition at line 137 of file hwcontext.h.

## hwctx

void* AVHWFramesContext::hwctx

The format-specific data, allocated and freed automatically along with this context.

The user shall ignore this field if the corresponding format-specific header (hwcontext_*.h) does not define a context to be used as AVHWFramesContext.hwctx.

Otherwise, it should be cast by the user to said context and filled as described in the documentation before calling av_hwframe_ctx_init().

After any frames using this context are created, the contents of this struct should not be modified by the caller.

Definition at line 153 of file hwcontext.h.

## free

void(* AVHWFramesContext::free) (struct AVHWFramesContext *ctx)

This field may be set by the caller before calling av_hwframe_ctx_init().

If non-NULL, this callback will be called when the last reference to this context is unreferenced, immediately before it is freed.

Definition at line 161 of file hwcontext.h.

## user_opaque

void* AVHWFramesContext::user_opaque

Arbitrary user data, to be used e.g.

by the free() callback.

Definition at line 166 of file hwcontext.h.

## pool

AVBufferPool* AVHWFramesContext::pool

A pool from which the frames are allocated by av_hwframe_get_buffer().

This field may be set by the caller before calling av_hwframe_ctx_init(). The buffers returned by calling av_buffer_pool_get() on this pool must have the properties described in the documentation in the corresponding hw type's header (hwcontext_*.h). The pool will be freed strictly before this struct's free() callback is invoked.

This field may be NULL, then libavutil will attempt to allocate a pool internally. Note that certain device types enforce pools allocated at fixed size (frame count), which cannot be extended dynamically. In such a case, initial_pool_size must be set appropriately.

Definition at line 181 of file hwcontext.h.

## initial_pool_size

int AVHWFramesContext::initial_pool_size

Initial size of the frame pool.

If a device type does not support dynamically resizing the pool, then this is also the maximum pool size.

May be set by the caller before calling av_hwframe_ctx_init(). Must be set if pool is NULL and the device type does not support dynamic pools.

Examples
  vaapi_encode.c.

Definition at line 190 of file hwcontext.h.

Referenced by set_hwframe_ctx().

## format

enum AVPixelFormat AVHWFramesContext::format

The pixel format identifying the underlying HW surface type.

Must be a hwaccel format, i.e. the corresponding descriptor must have the AV_PIX_FMT_FLAG_HWACCEL flag set.

Must be set by the user before calling av_hwframe_ctx_init().

Examples
  vaapi_encode.c.

Definition at line 200 of file hwcontext.h.

Referenced by set_hwframe_ctx().

## sw_format

enum AVPixelFormat AVHWFramesContext::sw_format

The pixel format identifying the actual data layout of the hardware frames.

Must be set by the caller before calling av_hwframe_ctx_init().

Note
  when the underlying API does not provide the exact data layout, but only the colorspace/bit depth, this field should be set to the fully planar version of that format (e.g. for 8-bit 420 YUV it should be AV_PIX_FMT_YUV420P, not AV_PIX_FMT_NV12 or anything else).

Examples
  vaapi_encode.c.

Definition at line 213 of file hwcontext.h.

Referenced by set_hwframe_ctx().

## width

int AVHWFramesContext::width

The allocated dimensions of the frames in this pool.

Must be set by the user before calling av_hwframe_ctx_init().

Examples
  vaapi_encode.c.

Definition at line 220 of file hwcontext.h.

Referenced by set_hwframe_ctx().

## height

int AVHWFramesContext::height

Examples
  vaapi_encode.c.

Definition at line 220 of file hwcontext.h.

Referenced by set_hwframe_ctx().

The documentation for this struct was generated from the following file:

- libavutil/hwcontext.h